# Chapter 11. The JavaScript Standard Library

## 11.1 Sets and Maps

### 11.1.1 The Set Class

### 11.1.2 The Map Class

### 11.1.3 WeakMap and WeakSet

## 11.2 Typed Arrays and Binary Data

### 11.2.1 Typed Array Types

### 11.2.2 Creating Typed Arrays

### 11.2.3 Using Typed Arrays

### 11.2.4 Typed Array Methods and Properties

### 11.2.5 DataView and Endianness

## 11.3 Pattern Matching with Regular Expressions

### 11.3.1 Defining Regular Expressions

### 11.3.2 String Methods for Pattern Matching

### 11.3.3 The RegExp Class

## 11.4 Dates and Times

### 11.4.1 Timestamps

### 11.4.2 Data Arithmetic

### 11.4.3 Formatting and Parsing Date Strings

## 11.5 Error Classes

## 11.6 JSON Serialization and Parsing

### 11.6.1 JSON Customizations

## 11.7 The Internationalization API

### 11.7.1 Formatting Numbers

### 11.7.2 Formatting Dates and Times

### 11.7.3 Comparing Strings

## 11.8 The Console API

### 11.8.1 Formatted Output with Console

## 11.9 URL APIs

### 11.9.1 Legacy URL Functions

## 11.10 Timers